"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var jsx_runtime_1 = require("react/jsx-runtime");
var BounceCheckbox_1 = __importDefault(require("./bouncecheckbox/BounceCheckbox"));
var styled_components_1 = __importDefault(require("styled-components"));
var react_beautiful_dnd_1 = require("react-beautiful-dnd");
var react_2 = require("react");
var FontSVG_1 = __importDefault(require("../assets/svg/FontSVG"));
var ContentQuestion = function (_a) {
    var alert = _a.alert, isOverflow = _a.isOverflow, taskList = _a.taskList, onUpdateTasks = _a.onUpdateTasks, onUpdateSelectQuestionIndex = _a.onUpdateSelectQuestionIndex, onUpdateCanvasAOIIndex = _a.onUpdateCanvasAOIIndex, onUpdateAOIMode = _a.onUpdateAOIMode;
    var _b = (0, react_2.useState)([]), tasks = _b[0], setTasks = _b[1];
    (0, react_2.useEffect)(function () {
        if (!taskList) {
            return;
        }
        setTasks(taskList);
    }, [taskList]);
    var _c = (0, react_2.useState)(0), currentSelectTasksIndex = _c[0], setCurrentSelectTasksIndex = _c[1];
    var _d = (0, react_2.useState)(""), addQuestionText = _d[0], setAddQuestionText = _d[1];
    var _e = (0, react_2.useState)(), fixText = _e[0], setFixText = _e[1];
    // question option text input state
    var _f = (0, react_2.useState)(""), addOptionText = _f[0], setAddOptionText = _f[1];
    var addQuestion = (0, react_2.useCallback)(function () {
        if (addQuestionText === "") {
            alert.error("비어있습니다. 추가 불가");
            return;
        }
        var findDuplicateQuestion = tasks.find(function (task) { return task.question === addQuestionText; });
        if (findDuplicateQuestion) {
            alert.error("문제가 중복됩니다. 추가 불가");
            return;
        }
        if (tasks.length >= 11) {
            alert.error("문제 생성은 최대 11문제입니다. 추가 불가");
            return;
        }
        onUpdateTasks(__spreadArray(__spreadArray([], tasks, true), [
            {
                question: addQuestionText,
                AOI: [],
                correctOption: null,
                showText: false,
                options: [],
            },
        ], false));
        setTasks(function (state) { return __spreadArray(__spreadArray([], state, true), [
            {
                question: addQuestionText,
                AOI: [],
                correctOption: null,
                showText: false,
                options: [],
            },
        ], false); });
        setAddQuestionText("");
    }, [tasks, addQuestionText, alert, onUpdateTasks]);
    var addOption = (0, react_2.useCallback)(function () {
        if (addOptionText === "") {
            alert.error("비어있습니다. 추가 불가");
            return;
        }
        var options = tasks[currentSelectTasksIndex].options;
        var findDuplicateQuestion = options.find(function (opt) { return opt === addOptionText; });
        if (findDuplicateQuestion) {
            alert.error("보기가 중복됩니다. 추가 불가");
            return;
        }
        if (options.length >= 5) {
            alert.error("보기 생성은 최대 5개 입니다. 추가 불가");
            return;
        }
        onUpdateTasks(tasks.map(function (task, idx) {
            return idx === currentSelectTasksIndex ? __assign(__assign({}, task), { options: __spreadArray(__spreadArray([], options, true), [addOptionText], false) }) : task;
        }));
        setTasks(function (state) {
            return state.map(function (task, idx) {
                return idx === currentSelectTasksIndex ? __assign(__assign({}, task), { options: __spreadArray(__spreadArray([], options, true), [addOptionText], false) }) : task;
            });
        });
        setAddOptionText("");
    }, [alert, tasks, addOptionText, currentSelectTasksIndex, onUpdateTasks]);
    var setCorrect = (0, react_2.useCallback)(function (optionIdx) {
        var opt = tasks[currentSelectTasksIndex].options[optionIdx];
        onUpdateTasks(tasks.map(function (task, idx) {
            return idx === currentSelectTasksIndex
                ? __assign(__assign({}, task), { correctOption: task.correctOption === opt ? null : opt }) : task;
        }));
        setTasks(function (state) {
            return state.map(function (task, idx) {
                return idx === currentSelectTasksIndex
                    ? __assign(__assign({}, task), { correctOption: task.correctOption === opt ? null : opt }) : task;
            });
        });
    }, [tasks, currentSelectTasksIndex, onUpdateTasks]);
    var fixQuestionOrOption = (0, react_2.useCallback)(function () {
        if (!fixText) {
            alert.error("수정 불가");
            return;
        }
        if (fixText.text === "") {
            alert.error("비어있습니다. 수정 불가");
            return;
        }
        if (fixText.type === "question") {
            if (tasks[fixText.idx].question === fixText.text) {
                alert.error("변경 사항이 없습니다. 수정 불가");
                return;
            }
            var findDuplicateQuestion = tasks.find(function (task) { return task.question === fixText.text; });
            if (findDuplicateQuestion) {
                alert.error("문제가 중복됩니다. 수정 불가");
                return;
            }
            onUpdateTasks(tasks.map(function (task, idx) {
                return idx === fixText.idx
                    ? __assign(__assign({}, task), { question: fixText.text }) : task;
            }));
            setTasks(function (state) {
                return state.map(function (task, idx) {
                    return idx === fixText.idx
                        ? __assign(__assign({}, task), { question: fixText.text }) : task;
                });
            });
        }
        else {
            var options = tasks[currentSelectTasksIndex].options;
            if (options[fixText.idx] === fixText.text) {
                alert.error("변경 사항이 없습니다. 수정 불가");
                return;
            }
            var findDuplicateQuestion = options.find(function (opt) { return opt === fixText.text; });
            if (findDuplicateQuestion) {
                alert.error("보기가 중복됩니다. 추가 불가");
                return;
            }
            onUpdateTasks(tasks.map(function (task, idx) {
                return idx === currentSelectTasksIndex
                    ? __assign(__assign({}, task), { correctOption: fixText.text === task.correctOption ? null : task.correctOption, options: task.options.map(function (opt, idx) { return (idx === fixText.idx ? fixText.text : opt); }) }) : task;
            }));
            setTasks(function (state) {
                return state.map(function (task, idx) {
                    return idx === currentSelectTasksIndex
                        ? __assign(__assign({}, task), { correctOption: fixText.text === task.correctOption ? null : task.correctOption, options: task.options.map(function (opt, idx) { return (idx === fixText.idx ? fixText.text : opt); }) }) : task;
                });
            });
        }
        setFixText(undefined);
    }, [alert, tasks, fixText, currentSelectTasksIndex, onUpdateTasks]);
    var swapTask = (0, react_2.useCallback)(function (type, oldIdx, newIdx) {
        if (!tasks) {
            return;
        }
        var newTasks = JSON.parse(JSON.stringify(tasks));
        if (type === "question") {
            var tmpTask = newTasks[oldIdx];
            newTasks[oldIdx] = newTasks[newIdx];
            newTasks[newIdx] = tmpTask;
        }
        else if (type === "options" || type === "AOI") {
            var selectTask = newTasks[currentSelectTasksIndex];
            var tmp = selectTask[type][oldIdx];
            selectTask[type][oldIdx] = selectTask[type][newIdx];
            selectTask[type][newIdx] = tmp;
        }
        onUpdateTasks(newTasks);
        setTasks(newTasks);
    }, [tasks, currentSelectTasksIndex, onUpdateTasks]);
    var invertShowText = (0, react_2.useCallback)(function () {
        if (currentSelectTasksIndex === 0) {
            alert.error("1번 문제는 수정할 수 없습니다.");
            return;
        }
        var task = tasks[currentSelectTasksIndex];
        var showText = task.showText;
        console.log("task", task);
        if (task.AOI.length > 0 && showText) {
            alert.error("핵심영역 내용이 있다면 반드시 공개해야 합니다.");
            return;
        }
        onUpdateTasks(tasks.map(function (task, idx) {
            return idx === currentSelectTasksIndex
                ? __assign(__assign({}, task), { showText: !showText }) : task;
        }));
        setTasks(function (state) {
            return state.map(function (task, idx) {
                return idx === currentSelectTasksIndex
                    ? __assign(__assign({}, task), { showText: !showText }) : task;
            });
        });
    }, [alert, tasks, currentSelectTasksIndex, onUpdateTasks]);
    var deleteQuestion = (0, react_2.useCallback)(function (idx) {
        onUpdateTasks(tasks.filter(function (_, i) { return i !== idx; }));
        setTasks(function (state) { return state.filter(function (_, i) { return i !== idx; }); });
        setCurrentSelectTasksIndex(0);
        onUpdateSelectQuestionIndex(0);
    }, [tasks, onUpdateSelectQuestionIndex, onUpdateTasks]);
    if (tasks.length > 0) {
        return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsxs)(StyledQuestion, { children: [(0, jsx_runtime_1.jsxs)(StyledQuestionTitle, { children: ["\uBB38\uC81C \uD56D\uBAA9\u00A0", (0, jsx_runtime_1.jsx)("span", __assign({ style: { fontSize: "0.8rem" } }, { children: "(\uCD5C\uB300 11\uAC1C)" }))] }), (0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.DragDropContext, __assign({ onDragEnd: function (e) {
                                if (!e.destination) {
                                    return;
                                }
                                if (e.destination.index === 0) {
                                    alert.error("1번 문제로 이동 할 수 없습니다.");
                                }
                                else if (e.destination.index >= tasks.length) {
                                    swapTask("question", e.source.index, tasks.length - 1);
                                }
                                else {
                                    swapTask("question", e.source.index, e.destination.index);
                                }
                            } }, { children: (0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.Droppable, __assign({ droppableId: "question" }, { children: function (provided) { return ((0, jsx_runtime_1.jsxs)(StyledQuestionList, __assign({}, provided.droppableProps, { ref: provided.innerRef }, { children: [tasks.map(function (task, idx) {
                                            var isFixThis = fixText && fixText.type === "question" && fixText.idx === idx ? true : false;
                                            return ((0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.Draggable, __assign({ draggableId: "task_".concat(idx), index: idx, isDragDisabled: idx === 0 }, { children: function (provided, snapshot) {
                                                    var cn = [];
                                                    if (currentSelectTasksIndex === idx) {
                                                        cn.push("active");
                                                    }
                                                    if (snapshot.isDragging) {
                                                        cn.push("dragging");
                                                    }
                                                    return ((0, jsx_runtime_1.jsxs)("li", __assign({ ref: provided.innerRef }, provided.dragHandleProps, provided.draggableProps, { className: cn.join(" "), onClick: function () {
                                                            if (idx !== currentSelectTasksIndex) {
                                                                setCurrentSelectTasksIndex(idx);
                                                                onUpdateSelectQuestionIndex(idx);
                                                            }
                                                        }, onDoubleClick: function () {
                                                            if (idx === 0) {
                                                                alert.error("1번 문제는 수정할 수 없습니다.");
                                                                return;
                                                            }
                                                            setFixText({
                                                                idx: idx,
                                                                type: "question",
                                                                text: task.question,
                                                            });
                                                        } }, { children: [(0, jsx_runtime_1.jsxs)("span", __assign({ style: { marginRight: 5 } }, { children: [idx + 1, "."] })), (0, jsx_runtime_1.jsx)("input", { className: isFixThis ? "edit" : "", type: "text", value: isFixThis ? fixText === null || fixText === void 0 ? void 0 : fixText.text : task.question, disabled: !isFixThis, ref: function (input) {
                                                                    if (isFixThis) {
                                                                        input === null || input === void 0 ? void 0 : input.focus();
                                                                    }
                                                                }, onChange: function (e) {
                                                                    if (isFixThis && fixText) {
                                                                        setFixText(__assign(__assign({}, fixText), { text: e.target.value }));
                                                                    }
                                                                }, onKeyDown: function (e) {
                                                                    if (e.key === "Escape") {
                                                                        setFixText(undefined);
                                                                    }
                                                                    else if (e.key === "Enter") {
                                                                        fixQuestionOrOption();
                                                                    }
                                                                }, onBlur: function () {
                                                                    setFixText(undefined);
                                                                } }), idx !== 0 && !isFixThis && ((0, jsx_runtime_1.jsxs)("div", __assign({ className: "editWrap" }, { children: [(0, jsx_runtime_1.jsx)("button", __assign({ onClick: function (e) {
                                                                            e.stopPropagation();
                                                                            setFixText({
                                                                                idx: idx,
                                                                                type: "question",
                                                                                text: task.question,
                                                                            });
                                                                        } }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "edit" }) })), (0, jsx_runtime_1.jsx)("button", __assign({ onClick: function (e) {
                                                                            e.stopPropagation();
                                                                            deleteQuestion(idx);
                                                                        } }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "trash" }) }))] })))] })));
                                                } }), "task_".concat(idx)));
                                        }), tasks.length < 11 && ((0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.Draggable, __assign({ draggableId: "task_add", index: tasks.length, isDragDisabled: true }, { children: function (provided) { return ((0, jsx_runtime_1.jsxs)("li", __assign({ ref: provided.innerRef }, provided.dragHandleProps, provided.draggableProps, { className: "addItem" }, { children: [(0, jsx_runtime_1.jsxs)("span", __assign({ style: { marginRight: 5 } }, { children: [tasks.length + 1, "."] })), (0, jsx_runtime_1.jsx)("input", { className: "edit", type: "text", value: addQuestionText, onChange: function (e) { return setAddQuestionText(e.target.value); }, onKeyDown: function (e) {
                                                            if (e.key === "Enter") {
                                                                addQuestion();
                                                            }
                                                        } }), (0, jsx_runtime_1.jsx)("div", __assign({ className: "svgWrapper", onClick: function () { return addQuestion(); } }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "add" }) }))] }))); } }), "task_add")), provided.placeholder] }))); } })) }))] }), (0, jsx_runtime_1.jsxs)(StyledOptionWrap, { children: [(0, jsx_runtime_1.jsxs)(StyledOptions, { children: [(0, jsx_runtime_1.jsxs)(StyledQuestionTitle, { children: ["\uBCF4\uAE30 \uD56D\uBAA9\u00A0", (0, jsx_runtime_1.jsx)("span", __assign({ style: { fontSize: "0.8rem" } }, { children: "(\uCD5C\uB300 5\uAC1C)" }))] }), (0, jsx_runtime_1.jsxs)(StyledOpenText, { children: [(0, jsx_runtime_1.jsx)(BounceCheckbox_1.default, { checked: tasks[currentSelectTasksIndex].showText, onChange: function () { return invertShowText(); } }), "\uBB38\uC81C \uD480 \uB54C \uC9C0\uBB38 \uACF5\uAC1C"] }), (0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.DragDropContext, __assign({ onDragEnd: function (e) {
                                        if (!e.destination) {
                                            return;
                                        }
                                        if (e.destination.index >= tasks.length) {
                                            swapTask("options", e.source.index, tasks[currentSelectTasksIndex].options.length - 1);
                                        }
                                        else {
                                            swapTask("options", e.source.index, e.destination.index);
                                        }
                                    } }, { children: (0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.Droppable, __assign({ droppableId: "option" }, { children: function (provided) { return ((0, jsx_runtime_1.jsxs)(StyledOptionList, __assign({}, provided.droppableProps, { ref: provided.innerRef }, { children: [tasks[currentSelectTasksIndex].options.map(function (opt, idx) {
                                                    var currentTask = tasks[currentSelectTasksIndex];
                                                    var isFixThis = fixText && fixText.type === "option" && fixText.idx === idx ? true : false;
                                                    return ((0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.Draggable, __assign({ draggableId: "opt_".concat(idx), index: idx, isDragDisabled: currentSelectTasksIndex === 0 }, { children: function (provided, snapshot) {
                                                            var cn = [];
                                                            if (opt === currentTask.correctOption) {
                                                                cn.push("correct");
                                                            }
                                                            if (snapshot.isDragging) {
                                                                cn.push("dragging");
                                                            }
                                                            return ((0, react_1.createElement)("li", __assign({ ref: provided.innerRef }, provided.dragHandleProps, provided.draggableProps, { key: "opt_".concat(idx), className: cn.join(" "), onDoubleClick: function () {
                                                                    if (currentSelectTasksIndex === 0) {
                                                                        alert.error("1번 문제는 수정할 수 없습니다.");
                                                                        return;
                                                                    }
                                                                    setFixText({
                                                                        idx: idx,
                                                                        type: "option",
                                                                        text: opt,
                                                                    });
                                                                } }),
                                                                (0, jsx_runtime_1.jsxs)("span", __assign({ style: { marginRight: 5 } }, { children: [idx + 1, "."] })),
                                                                (0, jsx_runtime_1.jsx)("input", { className: isFixThis ? "edit" : "", type: "text", value: isFixThis ? fixText === null || fixText === void 0 ? void 0 : fixText.text : opt, disabled: !isFixThis, ref: function (input) {
                                                                        if (isFixThis) {
                                                                            input === null || input === void 0 ? void 0 : input.focus();
                                                                        }
                                                                    }, onChange: function (e) {
                                                                        if (isFixThis && fixText) {
                                                                            setFixText(__assign(__assign({}, fixText), { text: e.target.value }));
                                                                        }
                                                                    }, onKeyDown: function (e) {
                                                                        if (e.key === "Escape") {
                                                                            setFixText(undefined);
                                                                        }
                                                                        else if (e.key === "Enter") {
                                                                            fixQuestionOrOption();
                                                                        }
                                                                    }, onBlur: function () {
                                                                        setFixText(undefined);
                                                                    } }),
                                                                currentSelectTasksIndex !== 0 && !isFixThis && ((0, jsx_runtime_1.jsxs)("div", __assign({ className: "editWrap" }, { children: [(0, jsx_runtime_1.jsx)("button", __assign({ title: "\uC815\uB2F5 \uCCB4\uD06C", onClick: function (e) {
                                                                                e.stopPropagation();
                                                                                setCorrect(idx);
                                                                            } }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "check" }) })), (0, jsx_runtime_1.jsx)("button", __assign({ title: "\uC218\uC815", onClick: function (e) {
                                                                                e.stopPropagation();
                                                                                setFixText({
                                                                                    idx: idx,
                                                                                    type: "option",
                                                                                    text: opt,
                                                                                });
                                                                            } }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "edit" }) })), (0, jsx_runtime_1.jsx)("button", __assign({ title: "\uC0AD\uC81C", onClick: function (e) {
                                                                                e.stopPropagation();
                                                                                onUpdateTasks(tasks.map(function (task, idx) {
                                                                                    return idx === currentSelectTasksIndex
                                                                                        ? __assign(__assign({}, task), { correctOption: task.options[idx] === task.correctOption
                                                                                                ? null
                                                                                                : task.correctOption, options: task.options.filter(function (o) { return o !== opt; }) }) : task;
                                                                                }));
                                                                                setTasks(function (state) {
                                                                                    return state.map(function (task, idx) {
                                                                                        return idx === currentSelectTasksIndex
                                                                                            ? __assign(__assign({}, task), { correctOption: task.options[idx] === task.correctOption
                                                                                                    ? null
                                                                                                    : task.correctOption, options: task.options.filter(function (o) { return o !== opt; }) }) : task;
                                                                                    });
                                                                                });
                                                                            } }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "trash" }) }))] })))));
                                                        } }), "opt_".concat(idx)));
                                                }), tasks[currentSelectTasksIndex].options.length < 5 && ((0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.Draggable, __assign({ draggableId: "opt_add", index: tasks[currentSelectTasksIndex].options.length, isDragDisabled: true }, { children: function (provided) { return ((0, jsx_runtime_1.jsxs)("li", __assign({ className: "addItem", ref: provided.innerRef }, provided.dragHandleProps, provided.draggableProps, { children: [(0, jsx_runtime_1.jsxs)("span", __assign({ style: { marginRight: 5 } }, { children: [tasks[currentSelectTasksIndex].options.length + 1, "."] })), (0, jsx_runtime_1.jsx)("input", { className: "edit", type: "text", value: addOptionText, onChange: function (e) { return setAddOptionText(e.target.value); }, onKeyDown: function (e) {
                                                                    if (e.key === "Enter") {
                                                                        addOption();
                                                                    }
                                                                } }), (0, jsx_runtime_1.jsx)("div", __assign({ className: "svgWrapper", onClick: function () { return addOption(); } }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "add" }) }))] }))); } }), "opt_add")), provided.placeholder] }))); } })) }))] }), (0, jsx_runtime_1.jsxs)(StyledAOI, { children: [(0, jsx_runtime_1.jsxs)(StyledQuestionTitle, { children: ["\uD575\uC2EC\uC601\uC5ED\u00A0", (0, jsx_runtime_1.jsx)("span", __assign({ style: { fontSize: "0.8rem" } }, { children: "(\uCD5C\uB300 3\uAC1C)" }))] }), (0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.DragDropContext, __assign({ onDragEnd: function (e) {
                                        if (!e.destination) {
                                            return;
                                        }
                                        swapTask("AOI", e.source.index, e.destination.index);
                                    } }, { children: (0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.Droppable, __assign({ droppableId: "AOI" }, { children: function (provided) { return ((0, jsx_runtime_1.jsxs)(StyledAOIList, __assign({}, provided.droppableProps, { ref: provided.innerRef }, { children: [tasks[currentSelectTasksIndex].AOI.map(function (aoi, idx) { return ((0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.Draggable, __assign({ draggableId: "aoi_".concat(idx), index: idx }, { children: function (provided, snapshot) {
                                                        var cn = [];
                                                        if (snapshot.isDragging) {
                                                            cn.push("dragging");
                                                        }
                                                        return ((0, react_1.createElement)("li", __assign({ ref: provided.innerRef }, provided.dragHandleProps, provided.draggableProps, { key: "aoi_".concat(idx), className: cn.join(" "), onMouseEnter: function () { return onUpdateCanvasAOIIndex(idx); }, onMouseLeave: function () { return onUpdateCanvasAOIIndex(-1); } }),
                                                            (0, jsx_runtime_1.jsxs)("span", { children: [idx + 1, ". ", aoi.name] }),
                                                            currentSelectTasksIndex !== 0 && ((0, jsx_runtime_1.jsxs)("div", __assign({ className: "editWrap" }, { children: [(0, jsx_runtime_1.jsx)("button", __assign({ title: "\uC218\uC815", onClick: function (e) {
                                                                            e.stopPropagation();
                                                                            onUpdateAOIMode("fix", {
                                                                                aoi: __assign({}, aoi),
                                                                                index: idx,
                                                                            });
                                                                        } }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "edit" }) })), (0, jsx_runtime_1.jsx)("button", __assign({ title: "\uC0AD\uC81C", onClick: function (e) {
                                                                            e.stopPropagation();
                                                                            onUpdateTasks(tasks.map(function (task, taskIndex) {
                                                                                return taskIndex === currentSelectTasksIndex
                                                                                    ? __assign(__assign({}, task), { AOI: task.AOI.filter(function (_, i) { return i !== idx; }) }) : task;
                                                                            }));
                                                                            setTasks(function (state) {
                                                                                return state.map(function (task, taskIndex) {
                                                                                    return taskIndex === currentSelectTasksIndex
                                                                                        ? __assign(__assign({}, task), { AOI: task.AOI.filter(function (_, i) { return i !== idx; }) }) : task;
                                                                                });
                                                                            });
                                                                            onUpdateCanvasAOIIndex(-1);
                                                                        } }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "trash" }) }))] })))));
                                                    } }), "aoi_".concat(idx))); }), currentSelectTasksIndex !== 0 && tasks[currentSelectTasksIndex].AOI.length < 3 && ((0, jsx_runtime_1.jsx)(react_beautiful_dnd_1.Draggable, __assign({ draggableId: "aoi_add", index: tasks[currentSelectTasksIndex].AOI.length, isDragDisabled: true }, { children: function (provided) { return ((0, jsx_runtime_1.jsx)("li", __assign({ ref: provided.innerRef }, provided.dragHandleProps, provided.draggableProps, { className: "addRange", title: "\uC601\uC5ED \uCD94\uAC00", onClick: function () {
                                                            if (!tasks) {
                                                                alert.error("추가 불가");
                                                                return;
                                                            }
                                                            if (!tasks[currentSelectTasksIndex].showText) {
                                                                alert.error("지문 공개를 먼저 해주세요.");
                                                                return;
                                                            }
                                                            if (isOverflow) {
                                                                alert.error("텍스트를 영역 안으로 조절한 후 시도해주세요.");
                                                                return;
                                                            }
                                                            if (tasks[currentSelectTasksIndex].AOI.length >= 3) {
                                                                alert.error("3개까지 추가 가능");
                                                                return;
                                                            }
                                                            onUpdateAOIMode("add");
                                                        } }, { children: (0, jsx_runtime_1.jsx)("div", __assign({ className: "svgWrapper" }, { children: (0, jsx_runtime_1.jsx)(FontSVG_1.default, { type: "add" }) })) }))); } }), "aoi_add")), provided.placeholder] }))); } })) }))] })] })] }));
    }
    else {
        return (0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, {});
    }
};
exports.default = (0, react_2.memo)(ContentQuestion);
var StyledQuestion = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject([""], [""])));
var StyledQuestionTitle = styled_components_1.default.h2(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  height: 50px;\n  padding-left: 10px;\n  display: flex;\n  align-items: center;\n  font-weight: 700;\n"], ["\n  height: 50px;\n  padding-left: 10px;\n  display: flex;\n  align-items: center;\n  font-weight: 700;\n"])));
var StyledQuestionCommonList = styled_components_1.default.ul(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  border: 1px solid #333;\n  overflow: hidden auto;\n  background-color: #f0f0f0;\n  li {\n    width: 100%;\n    padding-left: 5px;\n    height: 35px;\n    display: flex;\n    justify-content: space-between;\n    align-items: center;\n    cursor: pointer;\n    position: relative;\n\n    &:not(.addItem):hover {\n      background-color: #7367f0;\n      color: #fff;\n\n      input {\n        background-color: #7367f0;\n        color: #fff;\n\n        &.edit {\n          height: 80%;\n          background-color: #fff;\n          border: 1px solid #333;\n          cursor: text;\n          color: #333;\n        }\n      }\n\n      .editWrap {\n        opacity: 1;\n      }\n    }\n\n    &.active {\n      background-color: #7367f0;\n      color: #fff;\n\n      input {\n        background-color: #7367f0;\n        color: #fff;\n\n        &.edit {\n          height: 80%;\n          background-color: #fff;\n          border: 1px solid #333;\n          cursor: text;\n          color: #333;\n        }\n      }\n    }\n\n    &.dragging {\n      background: #8d83ff;\n      color: #fff;\n      input {\n        background-color: #8d83ff;\n        color: #fff;\n      }\n    }\n\n    &.addItem .svgWrapper,\n    &.addRange .svgWrapper {\n      margin: 0 5px;\n      height: 100%;\n      display: flex;\n      align-items: center;\n      &:hover {\n        svg {\n          fill: #000;\n        }\n      }\n      svg {\n        fill: #333;\n        height: 80%;\n      }\n    }\n\n    &.correct {\n      border: 2px solid #28a745;\n    }\n\n    &.addRange {\n      justify-content: center;\n    }\n\n    input {\n      flex: 1;\n      height: 100%;\n      border: none;\n      outline: none;\n      background-color: transparent;\n      font-size: 16px;\n      box-sizing: border-box;\n\n      cursor: pointer;\n\n      /* \uC904\uC784\uD45C \uC124\uC815\uD558\uAE30 */\n      text-overflow: ellipsis;\n      white-space: nowrap;\n      word-wrap: normal;\n      overflow: hidden;\n\n      &:disabled {\n        pointer-events: none;\n      }\n\n      &.edit {\n        height: 80%;\n        background-color: #fff;\n        border: 1px solid #333;\n        cursor: text;\n        color: #333;\n      }\n    }\n\n    .editWrap {\n      opacity: 0;\n      margin-right: 5px;\n      display: flex;\n      gap: 5px;\n      transition: 0.2s;\n      height: 100%;\n      justify-content: center;\n      align-items: center;\n      button {\n        height: 70%;\n        cursor: pointer;\n        border: none;\n        outline: none;\n        background-color: transparent;\n        &:hover {\n          svg {\n            fill: #fff;\n          }\n        }\n        i {\n          font-size: 20px;\n        }\n      }\n    }\n  }\n"], ["\n  border: 1px solid #333;\n  overflow: hidden auto;\n  background-color: #f0f0f0;\n  li {\n    width: 100%;\n    padding-left: 5px;\n    height: 35px;\n    display: flex;\n    justify-content: space-between;\n    align-items: center;\n    cursor: pointer;\n    position: relative;\n\n    &:not(.addItem):hover {\n      background-color: #7367f0;\n      color: #fff;\n\n      input {\n        background-color: #7367f0;\n        color: #fff;\n\n        &.edit {\n          height: 80%;\n          background-color: #fff;\n          border: 1px solid #333;\n          cursor: text;\n          color: #333;\n        }\n      }\n\n      .editWrap {\n        opacity: 1;\n      }\n    }\n\n    &.active {\n      background-color: #7367f0;\n      color: #fff;\n\n      input {\n        background-color: #7367f0;\n        color: #fff;\n\n        &.edit {\n          height: 80%;\n          background-color: #fff;\n          border: 1px solid #333;\n          cursor: text;\n          color: #333;\n        }\n      }\n    }\n\n    &.dragging {\n      background: #8d83ff;\n      color: #fff;\n      input {\n        background-color: #8d83ff;\n        color: #fff;\n      }\n    }\n\n    &.addItem .svgWrapper,\n    &.addRange .svgWrapper {\n      margin: 0 5px;\n      height: 100%;\n      display: flex;\n      align-items: center;\n      &:hover {\n        svg {\n          fill: #000;\n        }\n      }\n      svg {\n        fill: #333;\n        height: 80%;\n      }\n    }\n\n    &.correct {\n      border: 2px solid #28a745;\n    }\n\n    &.addRange {\n      justify-content: center;\n    }\n\n    input {\n      flex: 1;\n      height: 100%;\n      border: none;\n      outline: none;\n      background-color: transparent;\n      font-size: 16px;\n      box-sizing: border-box;\n\n      cursor: pointer;\n\n      /* \uC904\uC784\uD45C \uC124\uC815\uD558\uAE30 */\n      text-overflow: ellipsis;\n      white-space: nowrap;\n      word-wrap: normal;\n      overflow: hidden;\n\n      &:disabled {\n        pointer-events: none;\n      }\n\n      &.edit {\n        height: 80%;\n        background-color: #fff;\n        border: 1px solid #333;\n        cursor: text;\n        color: #333;\n      }\n    }\n\n    .editWrap {\n      opacity: 0;\n      margin-right: 5px;\n      display: flex;\n      gap: 5px;\n      transition: 0.2s;\n      height: 100%;\n      justify-content: center;\n      align-items: center;\n      button {\n        height: 70%;\n        cursor: pointer;\n        border: none;\n        outline: none;\n        background-color: transparent;\n        &:hover {\n          svg {\n            fill: #fff;\n          }\n        }\n        i {\n          font-size: 20px;\n        }\n      }\n    }\n  }\n"])));
var StyledQuestionList = (0, styled_components_1.default)(StyledQuestionCommonList)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  min-height: 316px;\n  max-height: 316px;\n"], ["\n  min-height: 316px;\n  max-height: 316px;\n"])));
var StyledOptionList = (0, styled_components_1.default)(StyledQuestionCommonList)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  min-height: 177px;\n  max-height: 177px;\n"], ["\n  min-height: 177px;\n  max-height: 177px;\n"])));
var StyledAOIList = (0, styled_components_1.default)(StyledQuestionCommonList)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  min-height: 107px;\n  max-height: 107px;\n"], ["\n  min-height: 107px;\n  max-height: 107px;\n"])));
var StyledOptionWrap = styled_components_1.default.div(templateObject_7 || (templateObject_7 = __makeTemplateObject([""], [""])));
var StyledOptions = styled_components_1.default.div(templateObject_8 || (templateObject_8 = __makeTemplateObject([""], [""])));
var StyledOpenText = styled_components_1.default.div(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n  padding-left: 10px;\n  display: flex;\n  gap: 5px;\n  height: 40px;\n"], ["\n  padding-left: 10px;\n  display: flex;\n  gap: 5px;\n  height: 40px;\n"])));
var StyledAOI = styled_components_1.default.div(templateObject_10 || (templateObject_10 = __makeTemplateObject([""], [""])));
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10;
